
#include "IMGNodeBsp.h"

namespace IMG {

NodeBsp::NodeBsp(){
	child[0] = NULL;
	child[1] = NULL;
	//bound.StartBoundingBox();
	bound = NULL;
	//id= NodeBsp::ID++;
	id = -1;
	fit = false;
}

Box2d * NodeBsp::GetBound() {
 
	return bound;   
}

void NodeBsp::Print() {
	printf("\nNode : %d, fit: %d", id, fit);
	if (bound) bound->Print();
	//if (plane) plane->Print();
}

//void SetPlane (Plane3 *pla) { plane = pla; }
//Plane3 * GetPlane () { return plane; }
NodeBsp * NodeBsp::Insert(int w, int h) {
	//printf("\nInsert del node: :%d (%d, %d)\n", id, w,  h);
	
	if (this->fit == true) return NULL;
	
	if (this->child[0] != NULL && this->child[1] != NULL)
	{
		NodeBsp * new_node = child[0]->Insert (w, h);
		
		if (new_node) return new_node;
		
		return child[1]->Insert(w,h);
	}
	
	if (!bound->In (w,h)) {//printf("\nNo hi quep!!!\n"); 
				return NULL; }
	
	if (bound->FitPerfect(w,h)){ //printf("\nFit Perfectly: \n"); 
				fit = true;  return this; }
	
	child[0] = new NodeBsp;
	child[1] = new NodeBsp;
	
	int dw, dh;
	Ogre::Vector2 min, max;
	float width, height;
	
	bound->Print();
	min = bound->GetMinimum();
	max = bound->GetMaximum();
	
	width = max.x - min.x;
	height = max.y - min.y;
	
	//printf("\nwidth: %.4f\n", width);
	//printf("\nheigth: %.4f\n", height);
	
	dw = (int) width - w;
	dh = (int) height - h;
	
	//printf("\n Valor dw: %d\n", dw);
	//printf("\n Valor dh: %d\n", dh);
	
	child[0]->bound = new Box2d;
	child[1]->bound = new Box2d;
	
	if (dw > dh)
	{	
		/*
		child[0]->bound->SetBoundBox(	min.x			, max.y, 
						min.x + width - 1	, min.y);		
		child[1]->bound->SetBoundBox(	min.x + width		, max.y, 
						max.x 			, min.y);				
		*/
		child[0]->bound->SetBoundBox(	min.x			, min.y, 
						min.x + w 		, max.y);		
						//min.x + w - 1		, max.y);		
		//child[1]->bound->SetBoundBox(	min.x + w + 1		, min.y, 
		child[1]->bound->SetBoundBox(	min.x + w 		, min.y, 
						max.x 			, max.y);										
	}
	else
	{		
		//child[0]->bound->SetBoundBox(	min.x			, max.y, 
		//				max.x 			, max.y + height - 1);
		child[0]->bound->SetBoundBox(	min.x 			, max.y - h ,
		//child[0]->bound->SetBoundBox(	min.x 			, max.y - h - 1 ,
						max.x			, max.y
						);
						
		//child[1]->bound->SetBoundBox(	min.x			, max.y + height, 
		//				max.x 			, min.y);
		child[1]->bound->SetBoundBox(	min.x			, min.y,
						//max.x			, max.y - h -1
						max.x			, max.y - h 
						);
	}
	
	//printf("\nImprimint child[0]: \n");
	//child[0]->Print();
	//printf("\nImprimint child[1]: \n");
	//child[1]->Print();
	
	return child[0]->Insert (w, h);
}

unsigned int NodeBsp::ID = 0;

NodeBsp::~NodeBsp() {
}


}
