
#include "LBBCKdTreeClusterSerializer.h"

namespace LBBC {

KdTreeClusterSerializer::KdTreeClusterSerializer() {
}

KdTreeClusterSerializer::~KdTreeClusterSerializer() {
}

void KdTreeClusterSerializer::writeBillboardCloud(TiXmlDocument *document)
{
	TiXmlNode *billboardCloudNode = document->InsertEndChild(TiXmlElement("billboardCloud"))->ToElement();

	unsigned int numSerializedBillboards = 0;
	unsigned int numSerializedEntities = 0;
	for (unsigned int iBillboard = 0; iBillboard < mBillboardCloud->getNumBillboards(); iBillboard++)
	{
		BBC::Billboard *billboard = mBillboardCloud->getBillboard(iBillboard);
		BBC::EntityCluster *entityCluster = billboard->getBillboardClusterData()->getEntityCluster();

		// If the Billboard has Entities...
		if (entityCluster->getNumEntitiesClusterData() > 0)
		{
			BillboardKdTreeClusterData *billboardKdTreeClusterData = (BillboardKdTreeClusterData*)billboard->getBillboardClusterData();
			billboardKdTreeClusterData->writeBillboardClusterData(billboardCloudNode);	
			numSerializedBillboards++;
			numSerializedEntities = numSerializedEntities + entityCluster->getNumEntitiesClusterData();
		}
	}
	billboardCloudNode->ToElement()->SetAttribute("count",Ogre::StringConverter::toString(numSerializedBillboards));
	
	Ogre::LogManager::getSingleton().logMessage("Num.Serialized Billboards:" + Ogre::StringConverter::toString(numSerializedBillboards) + " with " + Ogre::StringConverter::toString(numSerializedEntities) + " Entities");
}

}
